; GUI #
include win64a.inc
cdXPos          = 128
cdYPos          = 128
cdXSize         = 300
cdYSize         = 200
UnitPixel = 2
SmoothingModeAntiAlias = 4
StringAlignmentCenter = 1
FontStyleBold = 1
RectF struct
	X dd ?
	Y dd ?
        Width_ dd ?
        Height dd ?
RectF ends
.code
WinMain proc 
local msg:MSG
;  GDIPLUS
	invoke GdiplusStartup,&gdiplusToken,&gsi,0	
	xor ebx,ebx
	mov esi,IMAGE_BASE
	invoke	LoadCursorFromFileA,"br_Rabbit3.cur"
	mov	edi,offset ClassName
	push	rax	   ;hIconSm
	push	rdi	   ;lpszClassName
	push	rbx	   ;lpszMenuName
	push	COLOR_BTNFACE;hbrBackground
	push	rax	   ;hCursor
	push	rax       ;hIcon
	push	rsi	   ;hInstance
	push	rbx       ;cbClsExtra & cbWndExtra
	pushaddr WndProc     ;lpfnWndProc
      	push sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX
	push	rbx
	push	rsi	;rsi=400000h
	push	rbx
	push	rbx
	push	cdYSize
	push	cdXSize
	push	cdYPos
	push	cdXPos
	sub	esp,20h
    	invoke	CreateWindowExA,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_VISIBLE
    	lea edi,msg
@@:   	invoke	GetMessageA,edi,NULL,0,0
	invoke	DispatchMessageA,edi
        jmp @b
WinMain endp
WndProc proc hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT     

      	mov	hWnd,rcx
      	cmp	edx,WM_DESTROY
      	je	wmDESTROY
      	cmp	edx,WM_SIZE
      	je	wmSIZE
      	cmp	edx,WM_PAINT
      	je	wmPAINT
      	cmp	edx,WM_KEYDOWN
	je	wmKEYDOWN
      	cmp	edx,WM_CREATE
	je	wmCREATE
        leave
        jmp NtdllDefWindowProc_
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	jne	wmBYE
wmDESTROY:invoke GdipDeleteBrush,hBrush
	invoke GdipDisposeImage,hBitmap
;  GDI+
	mov	ecx,gdiplusToken
	invoke	GdiplusShutdown
	invoke	RtlExitUserProcess,NULL
;------------------------------------------------------------
wmPAINT:invoke	BeginPaint,hWnd,&ps
	invoke	GdipCreateFromHDC,eax,&graphics	
	invoke	GdipSetPageUnit,graphics,UnitPixel
	mov	eax,nHeight
	mov	[rsp+28h],rax
	mov	eax,nWidth
	mov	[rsp+20h],rax
	invoke	GdipDrawImageRectI,graphics,hBitmap,0,0
;                  
	invoke	GdipSetSmoothingMode,graphics, SmoothingModeAntiAlias;    
	invoke	GdipDrawString,graphics,szMensaje,-1,hFont,&rect,hStringFormat, hBrush
	invoke	GdipDeleteGraphics,graphics
        invoke	EndPaint,hWnd,&ps
	jmp	wmBYE
wmCREATE:invoke	GdipLoadImageFromFile,&FileName, &hBitmap
	invoke	GdipCreateStringFormat,0, 0, &hStringFormat
	invoke	GdipSetStringFormatAlign,hStringFormat, StringAlignmentCenter
	invoke	GdipSetStringFormatLineAlign,hStringFormat, StringAlignmentCenter
	invoke	GdipCreateFontFamilyFromName,&FontName, 0, &hFontFamily
	movd	xmm1,cdemSize
	invoke	GdipCreateFont,hFontFamily, , FontStyleBold, 3, &hFont
	invoke	GdipDeleteFontFamily,hFontFamily
	invoke	GdipCreateSolidFill,0FF0000FFh, &hBrush
	jmp	wmBYE
wmSIZE: mov eax,r9d
	and	eax,0FFFFh
	mov	nWidth,eax
	cvtsi2ss xmm0,eax
	movd	rect.Width_,xmm0;rect.Width  = (float) LOWORD (lParam) ;
	shr	r9d,10h
	mov	nHeight,r9d
	cvtsi2ss xmm0,r9d
	movd	rect.Height,xmm0;rect.Height = (float) HIWORD (lParam)
	invoke	InvalidateRect,hWnd, NULL,TRUE
wmBYE:  leave
        ret
WndProc endp
;---------------------------------------
.data
ClassName db '   GDI+',0
gsi GdiplusStartupInput <1,0,0,0,0>
szMensaje: du <  GDI+>
rect	RectF <0,0,0,0>
FontName: du <Tahoma>
FileName: du <Backgrnd.gif>
cdemSize        dd 36.0
.data?
gdiplusToken	dd ?
hBitmap		dq ?
hStringFormat	dq ?
hFont		dq ?
hFontFamily	dq ?
hBrush		dq ?
graphics	dq ?
nWidth		dd ?
nHeight		dd ?
end